local string = require("string")

function vrednost_izraza(perm, len)
	s = novi_stek(len)
	for i = 1, len do
		if isOperacija(perm[i]) == 0 then
			push(s, perm[i])
		else
			if s.br_elemenata < 2 then
				v = 404
				return 0
			end
			b = pop(s)
			a = pop(s)
			if perm[i] == "+" then
				v = a + b
			elseif perm[i] == "-" then
				v = a - b
			elseif perm[i] == "*" then
				v = a * b
			elseif perm[i] == "/" then
				if b == 0 or a % b ~= 0 then
					vrednost = 405
					return 0
				else
					v = a / b
				end
			end
			push(s, v)
		end
	end
	if s.br_elemenata ~= 1 then
		v = 406
		return 0
	else
		v = pop(s)
		return 1
	end
end


function novi_stek(n)
	s = {elementi = {}, velicina = n, br_elemenata = 0}
	return s
end

function push(s, n)
	if s.br_elemenata == s.velicina then
		return "Prekoracenje steka!"
	else
		s.elementi[s.br_elemenata] = n
		s.br_elemenata = s.br_elemenata + 1
	end
end

function pop(s)
	if isEmpty(s) == 1 then
		return "Potkoracenje steka!"
	end
	s.br_elemenata = s.br_elemenata - 1
	return s.elementi[s.br_elemenata]
end

function isEmpty(s)
	if s.br_elemenata > 0 then
		return 0
	else
		return 1
	end
end

function novi_stek_s(n)
	s = {elementi = {}, velicina = n, br_elemenata = 0}
	return s
end

function push_s(s, str)
	if s.br_elemenata == s.velicina then
		return "Prekoracenje steka!"
	end
	i = s.br_elemenata
	s.elementi[i] = str
	s.br_elemenata = s.br_elemenata + 1
end

function pop_s(s)
	s.br_elemenata = s.br_elemenata - 1
	return s.elementi[s.br_elemenata]
end

function isOperacija(c)
	if c == "+" or c == "-" or c == "*" or c == "/" then
		return 1
	else
		return 0
	end
end

function fact(n)
	if n == 0 then
		return 1
	else
		return n * fact(n - 1)
	end
end

function sve_permutacije(el, tren, i, n)
	if i == n + 1 then
		permutacije[tr_perm] = {}
		for i = 1, n do
			permutacije[tr_perm][i] = tren[i]
		end
		tr_perm = tr_perm + 1
	else
		for j = 1, n do
			if (i == 1 or i == 2) and isOperacija(el[j]) == 1 then
				a = 1
			else
				a = 0
			end
			if i == n and isOperacija(el[j]) == 0 then
				b = 1
			else
				b = 0
			end
			if oznacen[j] == 0 and a == 0 and b == 0 then
				oznacen[j] = 1
				tren[i] = el[j]
				sve_permutacije(el, tren, i + 1, n)
				oznacen[j] = 0
			end
		end
	end
end

function rpn_to_infix(niz)
	t = novi_stek_s(100)
	for i = 1, #niz do
		if isOperacija(niz[i]) == 0 then
			broj = niz[i]
			push_s(t, broj)
		else
			op = niz[i]
			desni = pop_s(t)
			levi = pop_s(t)
			ispis = ""
			ispis = ispis .. "(" .. tostring(levi) .. " " .. op .. " " .. tostring(desni) .. ")"
			push_s(t, ispis)
		end
	end
	io.write(string.format("%s = %.0f\n", pop(t), trazena_vrednost));
end


function sve_kombinacije(trenutna, at, i, k)
	if i == k then
		kombinacije[tr_komb] = {}
		for i = 1, #trenutna do
			kombinacije[tr_komb][i] = trenutna[i]
		end
		tr_komb = tr_komb + 1
	else
		for j = at, #operacije do
			trenutna[i] = operacije[j]
			sve_kombinacije(trenutna, j, i + 1, k)
		end
	end
end

function choose(n, k)
	local tmp = 1
	for i = n, n - k + 1, -1 do
		tmp = tmp * i
	end
	return tmp/fact(k)
end

operacije = {'+', '-', '*', '/'}
kombinacije = {}

tr_komb = 1

sve_kombinacije({}, 1, 1, 4)

permutacije = {}
izraz = {}

tr_perm = 1

for i = 1, 4 do
	izraz[i] = tonumber(io.read())
end

trazena_vrednost = tonumber(io.read())

br_k = choose(6, 3)
n = #izraz

oznacen = {}
for i = 1, 7 do
	oznacen[i] = 0
end

for i = 1, br_k do
	for j = 1, 3 do
		izraz[n + j] = kombinacije[i][j]
	end
--[[	for k = 1, #izraz do
		io.write(izraz[k])
	end
	print('\n') 
	]]
	sve_permutacije(izraz, {}, 1, #izraz)
--[[	
	for k = 1, #permutacije do
		for m = 1, #permutacije[k] do
			io.write(permutacije[k][m])
		end
		print('\n')
	end	
]]
	for k = 1, #permutacije do
		if vrednost_izraza(permutacije[k], 7) == 1 then
			if v == trazena_vrednost then
				rpn_to_infix(permutacije[k])
				return
			end
		end
	end
end